package jseifried.xaspecteditor.dj;
import java.util.Vector;

import edu.neu.ccs.demeter.aplib.cd.ClassGraph;
class SelVisitor extends UniversalVisitor {
  protected Vector names;
  public Vector get_names() { return names; }
  public void set_names(Vector new_names) { names = new_names; }
  protected Vector cgs;
  public Vector get_cgs() { return cgs; }
  public void set_cgs(Vector new_cgs) { cgs = new_cgs; }
  protected String errors;
  public String get_errors() { return errors; }
  public void set_errors(String new_errors) { errors = new_errors; }
  public SelVisitor() { super(); }
  public SelVisitor(Vector names, Vector cgs, String errors) {
    super();
    set_names(names);
    set_cgs(cgs);
    set_errors(errors);
  }
  public static SelVisitor parse(java.io.Reader in) throws ParseException { return new Parser(in)._SelVisitor(); }
  public static SelVisitor parse(java.io.InputStream in) throws ParseException { return new Parser(in)._SelVisitor(); }
  public static SelVisitor parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }

   public void before(SelectorL host) {
    ClassGraph cg = (ClassGraph)cgs.elementAt(names.indexOf(
      host.get_classdictionaryname().get_name().toString()));
    StrategyDef_List sdeflist = host.get_strategydef_list();
    SVisitor svisitor = new SVisitor(cg, "");
    sdeflist.universal_trv0(svisitor);
    set_errors(errors.concat(svisitor.get_errors()));
    NodeSubsetDef_List nodesubsetdeflist = host.get_nodesubsetdef_list();
    NSVisitor nsvisitor = new NSVisitor(
      host.get_classdictionaryname().get_name().toString(), cg, "");
    nodesubsetdeflist.universal_trv0(nsvisitor);
    set_errors(errors + nsvisitor.get_errors());
   }    
 
  void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
    super.universal_trv0_aft(_v_);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before_names(this, names);
    ((UniversalVisitor) _v_).after_names(this, names);
    ((UniversalVisitor) _v_).before_cgs(this, cgs);
    ((UniversalVisitor) _v_).after_cgs(this, cgs);
    ((UniversalVisitor) _v_).before_errors(this, errors);
    ((UniversalVisitor) _v_).after_errors(this, errors);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
